/* gdxcc.h
 * Header file for C-style interface to the GDX library
 * generated by apiwrapper
 */

#if ! defined(_GDXCC_H_)
#     define  _GDXCC_H_


enum gdxSyType {
  dt_set   = 0,
  dt_par   = 1,
  dt_var   = 2,
  dt_equ   = 3,
  dt_alias = 4  };

enum gdxSpecValue {
  sv_valund  = 0,
  sv_valna   = 1,
  sv_valpin  = 2,
  sv_valmin  = 3,
  sv_valeps  = 4,
  sv_normal  = 5,
  sv_acronym = 6  };

#include "gclgms.h"

#if defined(_WIN32)
# include <windows.h>
# define GDX_CALLCONV __stdcall
#else
# define GDX_CALLCONV
#endif

#if defined(__cplusplus)
extern "C" {
#endif

struct gdxRec;
typedef struct gdxRec *gdxHandle_t;

typedef int (*gdxErrorCallback_t) (int ErrCount, const char *msg);
extern int gdxAPIErrorCount;

/* headers for "wrapper" routines implemented in C */
int gdxGetReady  (char *msgBuf, int msgBufLen);
int gdxGetReadyD (const char *dirName, char *msgBuf, int msgBufLen);
int gdxGetReadyL (const char *libName, char *msgBuf, int msgBufLen);
int gdxCreate    (gdxHandle_t *pgdx, char *msgBuf, int msgBufLen);
int gdxCreateD   (gdxHandle_t *pgdx, const char *dirName, char *msgBuf, int msgBufLen);
int gdxCreateL   (gdxHandle_t *pgdx, const char *libName, char *msgBuf, int msgBufLen);
int gdxFree      (gdxHandle_t *pgdx);

int gdxLibraryLoaded(void);
int gdxLibraryUnload(void);

int  gdxGetScreenIndicator   (void);
void gdxSetScreenIndicator   (int scrind);
int  gdxGetExceptionIndicator(void);
void gdxSetExceptionIndicator(int excind);
int  gdxGetExitIndicator     (void);
void gdxSetExitIndicator     (int extind);
gdxErrorCallback_t gdxGetErrorCallback(void);
void gdxSetErrorCallback(gdxErrorCallback_t func);

void gdxErrorHandling(const char *msg);


#if defined(GDX_MAIN)    /* we must define some things only once */
# define GDX_FUNCPTR(NAME)  NAME##_t NAME = NULL
#else
# define GDX_FUNCPTR(NAME)  extern NAME##_t NAME
#endif

/* function typedefs and pointer definitions */

typedef void (GDX_CALLCONV *TDataStoreProc_t) (const int *Indx, const double *Vals);

typedef int  (GDX_CALLCONV *gdxAcronymCount_t) (gdxHandle_t pgdx);
GDX_FUNCPTR(gdxAcronymCount);
typedef int  (GDX_CALLCONV *gdxAcronymGetInfo_t) (gdxHandle_t pgdx, int N, char *AName, char *Atext, int *Indx);
GDX_FUNCPTR(gdxAcronymGetInfo);
typedef int  (GDX_CALLCONV *gdxAcronymIndex_t) (gdxHandle_t pgdx, double V);
GDX_FUNCPTR(gdxAcronymIndex);
typedef int  (GDX_CALLCONV *gdxAcronymName_t) (gdxHandle_t pgdx, double V, char *AName);
GDX_FUNCPTR(gdxAcronymName);
typedef int  (GDX_CALLCONV *gdxAcronymSetInfo_t) (gdxHandle_t pgdx, int N, const char *AName, const char *Atext, int Indx);
GDX_FUNCPTR(gdxAcronymSetInfo);
typedef double  (GDX_CALLCONV *gdxAcronymValue_t) (gdxHandle_t pgdx, int Indx);
GDX_FUNCPTR(gdxAcronymValue);
typedef int  (GDX_CALLCONV *gdxAddAlias_t) (gdxHandle_t pgdx, const char *AName1, const char *AName2);
GDX_FUNCPTR(gdxAddAlias);
typedef int  (GDX_CALLCONV *gdxAddSetText_t) (gdxHandle_t pgdx, const char *s, int *N);
GDX_FUNCPTR(gdxAddSetText);
typedef int  (GDX_CALLCONV *gdxAutoConvert_t) (gdxHandle_t pgdx, int NV);
GDX_FUNCPTR(gdxAutoConvert);
typedef int  (GDX_CALLCONV *gdxClose_t) (gdxHandle_t pgdx);
GDX_FUNCPTR(gdxClose);
typedef int  (GDX_CALLCONV *gdxDataErrorCount_t) (gdxHandle_t pgdx);
GDX_FUNCPTR(gdxDataErrorCount);
typedef int  (GDX_CALLCONV *gdxDataErrorRecord_t) (gdxHandle_t pgdx, int Rn, int *AElements, double *AVals);
GDX_FUNCPTR(gdxDataErrorRecord);
typedef int  (GDX_CALLCONV *gdxDataReadDone_t) (gdxHandle_t pgdx);
GDX_FUNCPTR(gdxDataReadDone);
typedef int  (GDX_CALLCONV *gdxDataReadFilteredStart_t) (gdxHandle_t pgdx, int SyNr, const int *ADomainNrs, int *NrRecs);
GDX_FUNCPTR(gdxDataReadFilteredStart);
typedef int  (GDX_CALLCONV *gdxDataReadMap_t) (gdxHandle_t pgdx, int Rn, int *AElements, double *AVals, int *AFDim);
GDX_FUNCPTR(gdxDataReadMap);
typedef int  (GDX_CALLCONV *gdxDataReadMapStart_t) (gdxHandle_t pgdx, int SyNr, int *NrRecs);
GDX_FUNCPTR(gdxDataReadMapStart);
typedef int  (GDX_CALLCONV *gdxDataReadRaw_t) (gdxHandle_t pgdx, int *AElements, double *AVals, int *AFDim);
GDX_FUNCPTR(gdxDataReadRaw);
typedef int  (GDX_CALLCONV *gdxDataReadRawStart_t) (gdxHandle_t pgdx, int SyNr, int *NrRecs);
GDX_FUNCPTR(gdxDataReadRawStart);
typedef int  (GDX_CALLCONV *gdxDataReadSlice_t) (gdxHandle_t pgdx, const char **AFiltElements, int *ADim, TDataStoreProc_t DP);
GDX_FUNCPTR(gdxDataReadSlice);
typedef int  (GDX_CALLCONV *gdxDataReadSliceStart_t) (gdxHandle_t pgdx, int ASyNr, int *ANrElems);
GDX_FUNCPTR(gdxDataReadSliceStart);
typedef int  (GDX_CALLCONV *gdxDataReadStr_t) (gdxHandle_t pgdx, char **AStrElements, double *AVals, int *AFDim);
GDX_FUNCPTR(gdxDataReadStr);
typedef int  (GDX_CALLCONV *gdxDataReadStrStart_t) (gdxHandle_t pgdx, int SyNr, int *NrRecs);
GDX_FUNCPTR(gdxDataReadStrStart);
typedef int  (GDX_CALLCONV *gdxDataSliceUELS_t) (gdxHandle_t pgdx, const int *AIndx, char **AUELs);
GDX_FUNCPTR(gdxDataSliceUELS);
typedef int  (GDX_CALLCONV *gdxDataWriteDone_t) (gdxHandle_t pgdx);
GDX_FUNCPTR(gdxDataWriteDone);
typedef int  (GDX_CALLCONV *gdxDataWriteMap_t) (gdxHandle_t pgdx, const int *AElements, const double *AVals);
GDX_FUNCPTR(gdxDataWriteMap);
typedef int  (GDX_CALLCONV *gdxDataWriteMapStart_t) (gdxHandle_t pgdx, const char *AName, const char *Atext, int ADim, int AType, int AUserInfo);
GDX_FUNCPTR(gdxDataWriteMapStart);
typedef int  (GDX_CALLCONV *gdxDataWriteRaw_t) (gdxHandle_t pgdx, const int *AElements, const double *AVals);
GDX_FUNCPTR(gdxDataWriteRaw);
typedef int  (GDX_CALLCONV *gdxDataWriteRawStart_t) (gdxHandle_t pgdx, const char *AName, const char *Atext, int ADim, int AType, int AUserInfo);
GDX_FUNCPTR(gdxDataWriteRawStart);
typedef int  (GDX_CALLCONV *gdxDataWriteStr_t) (gdxHandle_t pgdx, const char **AStrElements, const double *AVals);
GDX_FUNCPTR(gdxDataWriteStr);
typedef int  (GDX_CALLCONV *gdxDataWriteStrStart_t) (gdxHandle_t pgdx, const char *AName, const char *Atext, int ADim, int AType, int AUserInfo);
GDX_FUNCPTR(gdxDataWriteStrStart);
typedef int  (GDX_CALLCONV *gdxGetDLLVersion_t) (gdxHandle_t pgdx, char *V);
GDX_FUNCPTR(gdxGetDLLVersion);
typedef int  (GDX_CALLCONV *gdxErrorCount_t) (gdxHandle_t pgdx);
GDX_FUNCPTR(gdxErrorCount);
typedef int  (GDX_CALLCONV *gdxErrorStr_t) (gdxHandle_t pgdx, int N, char *s);
GDX_FUNCPTR(gdxErrorStr);
typedef int  (GDX_CALLCONV *gdxFileInfo_t) (gdxHandle_t pgdx, int *FileVer, int *ComprLev);
GDX_FUNCPTR(gdxFileInfo);
typedef int  (GDX_CALLCONV *gdxFileVersion_t) (gdxHandle_t pgdx, char *FileStr, char *ProduceStr);
GDX_FUNCPTR(gdxFileVersion);
typedef int  (GDX_CALLCONV *gdxFilterExists_t) (gdxHandle_t pgdx, int N);
GDX_FUNCPTR(gdxFilterExists);
typedef int  (GDX_CALLCONV *gdxFilterRegister_t) (gdxHandle_t pgdx, int V);
GDX_FUNCPTR(gdxFilterRegister);
typedef int  (GDX_CALLCONV *gdxFilterRegisterDone_t) (gdxHandle_t pgdx);
GDX_FUNCPTR(gdxFilterRegisterDone);
typedef int  (GDX_CALLCONV *gdxFilterRegisterStart_t) (gdxHandle_t pgdx, int Nr);
GDX_FUNCPTR(gdxFilterRegisterStart);
typedef int  (GDX_CALLCONV *gdxFindSymbol_t) (gdxHandle_t pgdx, const char *AName, int *AIx);
GDX_FUNCPTR(gdxFindSymbol);
typedef int  (GDX_CALLCONV *gdxGetElemText_t) (gdxHandle_t pgdx, int N, char *s, int *Node);
GDX_FUNCPTR(gdxGetElemText);
typedef int  (GDX_CALLCONV *gdxGetLastError_t) (gdxHandle_t pgdx);
GDX_FUNCPTR(gdxGetLastError);
typedef int  (GDX_CALLCONV *gdxGetSpecialValues_t) (gdxHandle_t pgdx, double *AVals);
GDX_FUNCPTR(gdxGetSpecialValues);
typedef int  (GDX_CALLCONV *gdxGetUEL_t) (gdxHandle_t pgdx, int UelNr, char *s);
GDX_FUNCPTR(gdxGetUEL);
typedef int  (GDX_CALLCONV *gdxMapValue_t) (gdxHandle_t pgdx, double D, int *sv);
GDX_FUNCPTR(gdxMapValue);
typedef int  (GDX_CALLCONV *gdxOpenRead_t) (gdxHandle_t pgdx, const char *Afn, int *ErrNr);
GDX_FUNCPTR(gdxOpenRead);
typedef int  (GDX_CALLCONV *gdxOpenWrite_t) (gdxHandle_t pgdx, const char *Afn, const char *AProducer, int *ErrNr);
GDX_FUNCPTR(gdxOpenWrite);
typedef int  (GDX_CALLCONV *gdxOpenWriteEx_t) (gdxHandle_t pgdx, const char *Afn, const char *AProducer, int Compr, int *ErrNr);
GDX_FUNCPTR(gdxOpenWriteEx);
typedef int  (GDX_CALLCONV *gdxResetSpecialValues_t) (gdxHandle_t pgdx);
GDX_FUNCPTR(gdxResetSpecialValues);
typedef int  (GDX_CALLCONV *gdxSetHasText_t) (gdxHandle_t pgdx, int N);
GDX_FUNCPTR(gdxSetHasText);
typedef int  (GDX_CALLCONV *gdxSetReadSpecialValues_t) (gdxHandle_t pgdx, const double *AVals);
GDX_FUNCPTR(gdxSetReadSpecialValues);
typedef int  (GDX_CALLCONV *gdxSetSpecialValues_t) (gdxHandle_t pgdx, const double *AVals);
GDX_FUNCPTR(gdxSetSpecialValues);
typedef int  (GDX_CALLCONV *gdxSetTextNodeNr_t) (gdxHandle_t pgdx, int N, int Node);
GDX_FUNCPTR(gdxSetTextNodeNr);
typedef int  (GDX_CALLCONV *gdxSetTraceLevel_t) (gdxHandle_t pgdx, int N, const char *s);
GDX_FUNCPTR(gdxSetTraceLevel);
typedef int  (GDX_CALLCONV *gdxSymbIndxMaxLength_t) (gdxHandle_t pgdx, int SyNr, int *DimInfo);
GDX_FUNCPTR(gdxSymbIndxMaxLength);
typedef int  (GDX_CALLCONV *gdxSymbMaxLength_t) (gdxHandle_t pgdx);
GDX_FUNCPTR(gdxSymbMaxLength);
typedef int  (GDX_CALLCONV *gdxSymbolAddComment_t) (gdxHandle_t pgdx, int SyNr, const char *s);
GDX_FUNCPTR(gdxSymbolAddComment);
typedef int  (GDX_CALLCONV *gdxSymbolGetComment_t) (gdxHandle_t pgdx, int SyNr, int N, char *s);
GDX_FUNCPTR(gdxSymbolGetComment);
typedef int  (GDX_CALLCONV *gdxSymbolGetDomain_t) (gdxHandle_t pgdx, int SyNr, int *DomainIDs);
GDX_FUNCPTR(gdxSymbolGetDomain);
typedef int  (GDX_CALLCONV *gdxSymbolInfo_t) (gdxHandle_t pgdx, int SyNr, char *AName, int *ADim, int *ATyp);
GDX_FUNCPTR(gdxSymbolInfo);
typedef int  (GDX_CALLCONV *gdxSymbolInfoX_t) (gdxHandle_t pgdx, int SyNr, int *ACount, int *AUserInfo, char *AExplTxt);
GDX_FUNCPTR(gdxSymbolInfoX);
typedef int  (GDX_CALLCONV *gdxSymbolSetDomain_t) (gdxHandle_t pgdx, const char **DomainIDs);
GDX_FUNCPTR(gdxSymbolSetDomain);
typedef int  (GDX_CALLCONV *gdxSystemInfo_t) (gdxHandle_t pgdx, int *NrSy, int *NrUel);
GDX_FUNCPTR(gdxSystemInfo);
typedef int  (GDX_CALLCONV *gdxUELMaxLength_t) (gdxHandle_t pgdx);
GDX_FUNCPTR(gdxUELMaxLength);
typedef int  (GDX_CALLCONV *gdxUELRegisterDone_t) (gdxHandle_t pgdx);
GDX_FUNCPTR(gdxUELRegisterDone);
typedef int  (GDX_CALLCONV *gdxUELRegisterMap_t) (gdxHandle_t pgdx, int UelNr, const char *Elem);
GDX_FUNCPTR(gdxUELRegisterMap);
typedef int  (GDX_CALLCONV *gdxUELRegisterMapStart_t) (gdxHandle_t pgdx);
GDX_FUNCPTR(gdxUELRegisterMapStart);
typedef int  (GDX_CALLCONV *gdxUELRegisterRaw_t) (gdxHandle_t pgdx, const char *Elem);
GDX_FUNCPTR(gdxUELRegisterRaw);
typedef int  (GDX_CALLCONV *gdxUELRegisterRawStart_t) (gdxHandle_t pgdx);
GDX_FUNCPTR(gdxUELRegisterRawStart);
typedef int  (GDX_CALLCONV *gdxUELRegisterStr_t) (gdxHandle_t pgdx, const char *Elem, int *UelNr);
GDX_FUNCPTR(gdxUELRegisterStr);
typedef int  (GDX_CALLCONV *gdxUELRegisterStrStart_t) (gdxHandle_t pgdx);
GDX_FUNCPTR(gdxUELRegisterStrStart);
typedef int  (GDX_CALLCONV *gdxUMFindUEL_t) (gdxHandle_t pgdx, const char *s, int *EN, int *UMap);
GDX_FUNCPTR(gdxUMFindUEL);
typedef int  (GDX_CALLCONV *gdxUMUelGet_t) (gdxHandle_t pgdx, int N, char *s, int *UMap);
GDX_FUNCPTR(gdxUMUelGet);
typedef int  (GDX_CALLCONV *gdxUMUelInfo_t) (gdxHandle_t pgdx, int *NrElem, int *HighMap);
GDX_FUNCPTR(gdxUMUelInfo);
typedef int  (GDX_CALLCONV *gdxCurrentDim_t) (gdxHandle_t pgdx);
GDX_FUNCPTR(gdxCurrentDim);
#if defined(__cplusplus)
}
#endif
#endif /* #if ! defined(_GDXCC_H_) */
